#ifndef EM_H
#define EM_H

#include <cuda.h>
#include <cutil.h>
#include <cutil_inline.h>
#include "../share/macro.h"

extern "C"
void CUDA_calcMembership(int GROUPOFTRAJECTORY, int grid_size, int block_size, float* pTMatrix,float* pTrajectory_temp, float* pflMu, float* pflInvDelta, float *dsigma, float* pfAlpha, float* SumofPik,float* pfMembership, float* pfPointMembership, int* pPointCount,int* pInitIndex,float* pfScale, int iTotalPointCount, int iRow, int nSelectedTrajNum);

extern "C"
void free_cuda_array_float(float *cuda_array);

extern "C"
void free_cuda_array_int(int *cuda_array);

extern "C"
void create_cuda_array_float(float **cuda_array, int array_size);

extern "C"
void create_cuda_array_int(int **cuda_array, int array_size);

extern "C"
void copy_to_cuda_array_float(float *cuda_array, float *cpu_array, int array_size);

extern "C"
void copy_to_cuda_array_int(int *cuda_array, int *cpu_array, int array_size);

extern "C"
void copy_from_cuda_array_float(float *cuda_array, float *cpu_array, int array_size);

extern "C"
void copy_from_cuda_array_int(int *cuda_array, int *cpu_array, int array_size);

#endif
