#ifndef BSPLINE_H
#define BSPLINE_H 

#include <cuda.h>
#include <cutil.h>
#include <cutil_inline.h>

extern "C"
void CUDA_genBSpline2D(int grid_size, int block_size, float* trajectory, 
                     int* pointcount, int* initialindex, float* knots, 
                     int* pointcount_K, int* initialindex_K, 
                     float* trajectory_B, float* speed, float* length, 
                     int trajnum, unsigned long totalcountnum, int degree, 
                     int samplenum, int nSelectedTrajNum);
extern "C"
void CUDA_genBSpline3D(int grid_size, int block_size, float* trajectory, 
                     int* pointcount, int* initialindex, float* knots, 
                     int* pointcount_K, int* initialindex_K, 
                     float* trajectory_B, float* speed, float* length, 
                     int trajnum, unsigned long totalcountnum, int degree, 
                     int samplenum, int nSelectedTrajNum);


extern "C"
void CUDA_reParameter(int grid_size, int block_size, float* trajectory_B, float* speed, float* length, int* pointcount,float* percentage, int* initialindex, float* trajectory_B_sampled, int totalcountnum_S, unsigned long totalcountnum, int trajnum, int samplenum, int nSelectedTrajNum);

extern "C"
void free_cuda_array_float(float *cuda_array);

extern "C"
void free_cuda_array_int(int *cuda_array);

extern "C"
void create_cuda_array_float(float **cuda_array, int array_size);

extern "C"
void create_cuda_array_int(int **cuda_array, int array_size);

extern "C"
void copy_to_cuda_array_float(float *cuda_array, float *cpu_array, int array_size);

extern "C"
void copy_to_cuda_array_int(int *cuda_array, int *cpu_array, int array_size);

extern "C"
void copy_from_cuda_array_float(float *cuda_array, float *cpu_array, int array_size);

extern "C"
void copy_from_cuda_array_int(int *cuda_array, int *cpu_array, int array_size);
                                 
#endif


