// line length file
#include "mpi.h"
#include <iostream>
#include <fstream>
#include <assert.h>
#include <sys/time.h>
#include <vector>
#include <stdlib.h>

#include "BSpline.h"
#include "macro.h"
#include "float.h"
#include "time.h"
#include "cxgl.h"

#include "jsoncpp/json.h"
using namespace std;

double GetTime()
{
    //struct timeval start;
    //gettimeofday(&start, 0);
    
    //double seconds = start.tv_sec + start.tv_usec * 1e-6;
    //return seconds;
	double seconds;
	seconds = MPI_Wtime();
	return seconds;
}

int iDivUp(int a, int b)
{
    return (a % b != 0) ? (a / b + 1) : (a / b);
}

int main(int argc, char** argv)
{
 int GROUPOFTRAJECTORY = 12;
 int direc = atoi(argv[1]);

  if(direc > 0)
        GROUPOFTRAJECTORY = atoi(argv[1]); 
    else{
     bool alive = true;
        while (alive){
            Json::Value root;
            Json::Reader reader;
            std::ifstream test("../clusters.json", std::ifstream::binary);
            bool parsingSuccessful = reader.parse( test, root, false );
            if ( !parsingSuccessful ){
                std::cout  << reader.getFormatedErrorMessages() << "\n";}
            const Json::Value clusternum = root["ClusterNumber"];
            GROUPOFTRAJECTORY = clusternum.asInt();
         alive = false;
	}
    }
    //int GROUPOFTRAJECTORY =atoi( argv[1]); 
    //int GROUPOFTRAJECTORY = 10;
    ifstream infile;
    ofstream outf;
    char cFileName[1000];
    
    /*Information maintianed for trajectories*/
    float **pTrajectory_orig = NULL;
    
    //trajectory parameters: trajectories in arrays, original or sampled
    float **pTrajectory_sample = NULL;
    float *pTrajectory_temp = NULL;
    float *pAngle_temp = NULL;
    float *pTorsion_temp = NULL;
    float *pTrajectory_B = NULL;
    
    //trajectory parameters: rearranged trajectories in one array
    float *pfSpeed = NULL;
    int   *pPointCount = NULL;
    int   *pInitIndex = NULL;
    //used when filtering
    int   *pPointCount_temp = NULL; 
    //used when filtering
    int   *pInitIndex_temp = NULL;
    //trajectory parameters: point number and initial point initial index of each trajectory
    unsigned long iTotalPointCount;
    // the length of each trajectory after normalization
    float *pfLength = NULL ;    
    /*Information maintianed for trajectories*/
    
    /*BSpline Knots*/
    float *pfKnots = NULL;
    int   *pnPointCount_K = NULL;
    int   *pnInitIndex_K = NULL;
    /*BSpline Knots*/
    
    /*The corresponding trajectory information on GPU*/
    float *trajectory = NULL;
    float *trajectory_B = NULL;
    float *trajectory_B_sampled = NULL;
    float *knots = NULL;
    float *length = NULL;
    float *speed = NULL;//GPU input trajectory
    int   *initialindex = NULL;
    int   *pointcount = NULL;
    int   *initialindex_K = NULL;
    int   *pointcount_K = NULL;//GPU trajectory information
    float *percentage = NULL;
    /*The corresponding trajectory information on GPU*/
    
    /*For EM algorithm and other temporal variables*/
    int     nMaxPointCount, nSelectedTrajNum;
    float   a, b;
    float   scale_v[DIMENSION];
    float   Max_mv[DIMENSION], Min_mv[DIMENSION];
    float   *Max_v[DIMENSION], *Min_v[DIMENSION];
    /*For EM algorithm and other temporal variables*/
    
    int iPointCount;
    int linenum, linenum_to_read, line_start;    
    int myrank_mpi, nprocs_mpi;

    MPI_Win countwin;
	MPI_File thefile;
	int* gpiCount = NULL;
	int* gpiCount1 = NULL;
    int send_count, recv_count;
    ///////////////////////////////////////////////////////////
    double start, end, seconds;
    ///////////////////////////////////////////////////////////
    
    cudaError_t error;
        
    MPI_Init( &argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &myrank_mpi);
    MPI_Comm_size(MPI_COMM_WORLD, &nprocs_mpi);
if(myrank_mpi > 0){
cerr << "++++++++++++++++++++++++ " << myrank_mpi << endl;
    }
    iTotalPointCount = 0;
    nMaxPointCount = -INT_MAX;
   
    char filename[] = DAT_FILE;
    
    ifstream inf(filename, ios::binary);
    assert(inf);
    // read line data
    inf.read(reinterpret_cast<char*>(&linenum), sizeof(int));
 
    linenum_to_read = RANGE_SIZE(myrank_mpi, nprocs_mpi, linenum);
    line_start = RANGE_LOW(myrank_mpi, nprocs_mpi, linenum);
    if(myrank_mpi == 0){     
    cerr << myrank_mpi 
         << " read " << linenum_to_read
         << " start " << line_start 
         <<  endl;
    }
    pTrajectory_orig    = new float*[linenum_to_read];
    pTrajectory_sample  = new float*[linenum_to_read];
    pPointCount         = new int[linenum_to_read];
    pInitIndex          = new int[linenum_to_read];
    pPointCount_temp    = new int[linenum_to_read];
    pInitIndex_temp     = new int[linenum_to_read];
    nMaxPointCount      = 0;
   cout<<"linenum "<<linenum<<endl; 
    int readnum = 0;
    for (int i = 0; i < linenum; i++) {
        
        cxLine *line = new cxLine;
        line->Read(inf);
                
        if (i < line_start) {
            delete line;
            continue;
        }
        
        vector<cxLinePoint> &para_line = line->GetParaLine();
        
        iPointCount = para_line.size();
        pInitIndex[readnum] = iTotalPointCount;
        pPointCount[readnum] = iPointCount;
        
        iTotalPointCount += iPointCount;
        
        if (nMaxPointCount < iPointCount) {
            nMaxPointCount = iPointCount;
        }
        
        pTrajectory_orig[readnum] = new float[iPointCount*DIMENSION];
        
        for (int j = 0; j < para_line.size(); j++) {
            for (int d = 0; d < DIMENSION; d++) {
                pTrajectory_orig[readnum][j*DIMENSION+d] = (para_line[j].Pos())[d];
	        //if(myrank_mpi == 0){
		  //  cout<<" "<<pTrajectory_orig[readnum][j*DIMENSION+d];
		//} 
	    }
	    //if(myrank_mpi == 0)
	//	cout<<"; ";
        }        
       // if(myrank_mpi == 0)
	 //   cout<<endl;
        delete line;
        
        readnum++;
        if (readnum >= linenum_to_read) {
            break;
        }
    }    
    inf.close();
cout<<"rank "<<myrank_mpi<<" reading done!"<<endl;
    iTotalPointCount = 0;
    iPointCount = 0;
    
    for (int d = 0; d < DIMENSION; d++) {
        Max_v[d] = new float[linenum_to_read];
        Min_v[d] = new float[linenum_to_read];
    }
    
    for (int i = 0; i < linenum_to_read; i++){                
        for (int d = 0; d < DIMENSION; d++) {
            Max_v[d][i] = -FLT_MAX;
            Min_v[d][i] = FLT_MAX;
        }
        
        pInitIndex[i]          = iTotalPointCount;
        pPointCount[i]         = int(pPointCount[i]/SAMPLE_STEP);        
        pInitIndex_temp[i]     = pInitIndex[i];
        pPointCount_temp[i]    = pPointCount[i];
        iTotalPointCount      += pPointCount[i];
        pTrajectory_sample[i]  = new float[pPointCount[i]*DIMENSION];
        
        for(int j = 0; j < pPointCount[i]; j++) {            
            for (int d = 0; d < DIMENSION; d++) {
                pTrajectory_sample[i][j * DIMENSION + d] 
                    = pTrajectory_orig[i][j * SAMPLE_STEP * DIMENSION + d];
                
                if (Max_v[d][i] < pTrajectory_sample[i][j*DIMENSION + d]) {
                    Max_v[d][i] = pTrajectory_sample[i][j*DIMENSION + d];
                }
                
                if (Min_v[d][i] > pTrajectory_sample[i][j*DIMENSION + d]) {
                    Min_v[d][i] = pTrajectory_sample[i][j*DIMENSION + d];
                }
            }
        }
    }
    
    for (int d = 0; d < DIMENSION; d++) {
        Max_mv[d] = -FLT_MAX;
        Min_mv[d] = FLT_MAX;
    }    
    
    for (int i = 0; i < linenum_to_read; i ++)
    {
        for (int d = 0; d < DIMENSION; d++) 
        {
            if (Max_mv[d] < Max_v[d][i]) {
                Max_mv[d] = Max_v[d][i];
            }
            if (Min_mv[d] > Min_v[d][i]) {
                Min_mv[d] = Min_v[d][i];
            }
        }
    }
    
    for (int d = 0; d < DIMENSION; d++) {        
        scale_v[d] = Max_mv[d] - Min_mv[d];
    }
    
    iTotalPointCount = 0;
    nSelectedTrajNum = 0;
    /////////////////////Rearrange trajectories////////////////////////////
    //sprintf(cFileName, "%s/Selected_%04d.txt", OUT_PATH, myrank_mpi);    
    //outf.open(cFileName);    
    for(int i = 0; i < linenum_to_read; i ++) {
        bool passed = true;
        for (int d = 0; d < DIMENSION; d++) {
            if ((Max_v[d][i] - Min_v[d][i]) < scale_v[d] * VALUE_SPAN_THRESHOLD ||  pPointCount_temp[i] < POINT_NUM_THRESHOLD_MIN || pPointCount_temp[i] > POINT_NUM_THRESHOLD_MAX) 
            {
                passed = false;
                break;
            }        
        } 
        if (passed) {
            iTotalPointCount += pPointCount[i];
           // outf<<i<<endl;
            nSelectedTrajNum ++;
        }
    }
    
    //outf.close();    
    //cout<<"The Selected Trajectory Number is "<< nSelectedTrajNum<<endl;
    
    if(pPointCount != NULL) {
        delete []pPointCount;
        pPointCount = NULL;
    }
    pPointCount  = new int[nSelectedTrajNum];
    
    if(pInitIndex != NULL) {
        delete []pInitIndex;
        pInitIndex = NULL;
    }    
    pInitIndex  = new int[nSelectedTrajNum];
      
	
	if(gpiCount != NULL){
		delete []gpiCount;
		gpiCount = NULL;
	}
    gpiCount = new int[nprocs_mpi];
	gpiCount1 = new int[nprocs_mpi];
	
	MPI_Barrier(MPI_COMM_WORLD);
	int totallinenum = 0;
	send_count = recv_count = 1;
	MPI_Allgather(&nSelectedTrajNum, send_count, MPI_INT,
	              gpiCount, recv_count, MPI_INT, 
				  MPI_COMM_WORLD);
	
	for(int i = 0; i < nprocs_mpi; i++) 
	{
		totallinenum += gpiCount[i];
	}

	MPI_Barrier(MPI_COMM_WORLD);
	MPI_Allgather(&linenum_to_read, send_count, MPI_INT,
	              gpiCount, recv_count, MPI_INT, 
				  MPI_COMM_WORLD);
	
	MPI_Barrier(MPI_COMM_WORLD);	
	MPI_Allgather(&iTotalPointCount, send_count, MPI_INT,
	              gpiCount1, recv_count, MPI_INT, 
				  MPI_COMM_WORLD);
	
	if(myrank_mpi == 0)
	{
		sprintf(cFileName, "%s/IndexCount.txt", OUT_PATH);
		outf.open(cFileName);
		assert(outf);
		outf<<totallinenum<<endl;	
		outf.close();
	}
    int temp = 0;
    iTotalPointCount = 0;    
	int temp_iTotalPointCount = 0;
		
	for(int j = 0; j < nprocs_mpi; j++)
	{
		if(myrank_mpi == j)
		{
			sprintf(cFileName, "%s/IndexCount.txt", OUT_PATH);
			outf.open(cFileName, ios::out|ios::app);
			assert(outf);
			int currentpointer = 0;
			int currentpointer1 = 0;
			for(int i = 0; i < myrank_mpi; i++) 
			{
				currentpointer += gpiCount[i];
			}
			for(int i = 0; i < myrank_mpi; i++) 
			{
				currentpointer1 += gpiCount1[i];
			}
		
			for(int i = 0; i < linenum_to_read; i ++) {
        	bool passed = true;
        	for (int d = 0; d < DIMENSION; d++) {
            
            if ((Max_v[d][i] - Min_v[d][i]) < scale_v[d] * VALUE_SPAN_THRESHOLD ||  pPointCount_temp[i] < POINT_NUM_THRESHOLD_MIN || pPointCount_temp[i] > POINT_NUM_THRESHOLD_MAX) 
             
				{
               		passed = false;
                	break;
            	}        
        	} 
        
			if (passed) {
            	pPointCount[temp] = pPointCount_temp[i];
            	pInitIndex[temp]  = iTotalPointCount;
        		iTotalPointCount += pPointCount_temp[i];
				outf<<currentpointer+i<<" "<<currentpointer1 + 
				temp_iTotalPointCount<<" "<<pPointCount[temp]<<endl;
				
            	temp = temp + 1;
        	}

        	temp_iTotalPointCount += pPointCount_temp[i];
    	}

		outf.close();
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}

   //cout<<"rank "<<myrank_mpi<<" IndexCount.txt is written!"<<endl; 

    pTrajectory_temp = new float[iTotalPointCount*DIMENSION];
    temp = 0;
    
    //Not worth working on GPU
    for (int i = 0; i < linenum_to_read; i ++) 
    {
        bool passed = true;
        for (int d = 0; d < DIMENSION; d++) {
            if ((Max_v[d][i] - Min_v[d][i]) < scale_v[d] * VALUE_SPAN_THRESHOLD ||  pPointCount_temp[i] < POINT_NUM_THRESHOLD_MIN || pPointCount_temp[i] > POINT_NUM_THRESHOLD_MAX) 
             
            {
                passed = false;
                break;
            }        
        }
		
        
        if(passed)
        {
            for (int j = 0; j < pPointCount_temp[i]; j++)
            {
                for (int d = 0; d < DIMENSION; d++) 
                {
                    //normalization
                    pTrajectory_temp[d*iTotalPointCount + pInitIndex[temp] + j] = (pTrajectory_sample[i][j*DIMENSION + d] - Min_mv[d])/scale_v[d];
                }
            }            
            temp++;
        }
    }
    
    pfKnots = new float[iTotalPointCount+nSelectedTrajNum*(BSPLINE_DEGREE + 1)];
    pnInitIndex_K = new int[nSelectedTrajNum];
    pnPointCount_K = new int[nSelectedTrajNum];
    int totalknotpoint = 0;
    int knotnum = 0;
    int m_numCP;
        
    for(int n = 0; n < nSelectedTrajNum; n++)
    {
        m_numCP = pPointCount[n];
        pnInitIndex_K[n] = totalknotpoint;
        knotnum = m_numCP + BSPLINE_DEGREE + 1;
        pnPointCount_K[n] = knotnum;
        
        //	cout<<pnPointCount_K[n]<<"    ";
        //	cout<<pnInitIndex_K[n]<<"    ";
        
        for (int i = 0; i <= BSPLINE_DEGREE; i++) {
            pfKnots[totalknotpoint + i] = 0.0;
            pfKnots[totalknotpoint + knotnum- i - 1] = 1.0;
        }
        
        float delta = 1.0/(m_numCP - BSPLINE_DEGREE);
        for (int j = 1; j <= m_numCP - BSPLINE_DEGREE -1; j++) {            
            pfKnots[totalknotpoint + j + BSPLINE_DEGREE] = delta*j;            
        }
        
        totalknotpoint += knotnum;
    }
    start = GetTime();
        
    cout<<"rank "<<myrank_mpi<<" "<<nSelectedTrajNum<<" "<<iTotalPointCount<<endl; 
MPI_Barrier(MPI_COMM_WORLD);

    /////////////////GPU BSpline Generation////////////////////
    int array_size = iTotalPointCount * DIMENSION;
    create_cuda_array_float(&trajectory, array_size);
    copy_to_cuda_array_float(trajectory, pTrajectory_temp, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_int(&pointcount, array_size);
    copy_to_cuda_array_int(pointcount, pPointCount, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_int(&initialindex, array_size);
    copy_to_cuda_array_int(initialindex, pInitIndex, array_size);
    
    array_size = nSelectedTrajNum * SAMPLE_NUM * DIMENSION;
    create_cuda_array_float(&trajectory_B, array_size);
    
    array_size = nSelectedTrajNum * SAMPLE_NUM ;
    create_cuda_array_float(&speed, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_float(&length, array_size);
    
    array_size = totalknotpoint;
    create_cuda_array_float(&knots, array_size);
    copy_to_cuda_array_float(knots, pfKnots, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_int(&pointcount_K, array_size);
    copy_to_cuda_array_int(pointcount_K, pnPointCount_K, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_int(&initialindex_K, array_size);
    copy_to_cuda_array_int(initialindex_K, pnInitIndex_K, array_size);
    
    end = GetTime();
    seconds = end - start;
    // cout<<"The Data Transmition(to GPU) Time 1 is "<<seconds<<endl;
    
    //cout << myrank_mpi << " generating BSpline start!"  << endl;
    start = GetTime();
    int nGridSize = iDivUp(nSelectedTrajNum, BLOCK_SIZE);
	if(DIMENSION == 2){
    	CUDA_genBSpline2D(nGridSize, BLOCK_SIZE, trajectory, pointcount, initialindex, knots, pointcount_K, initialindex_K, trajectory_B, speed, length, nSelectedTrajNum, iTotalPointCount, BSPLINE_DEGREE, SAMPLE_NUM, nSelectedTrajNum);
	}
    if(DIMENSION == 3){
    	CUDA_genBSpline3D(nGridSize, BLOCK_SIZE, trajectory, pointcount, initialindex, knots, pointcount_K, initialindex_K, trajectory_B, speed, length, nSelectedTrajNum, iTotalPointCount, BSPLINE_DEGREE, SAMPLE_NUM, nSelectedTrajNum);
    }
	
	end = GetTime();
    seconds = end - start;
 
    error = cudaThreadSynchronize();
    cout<<myrank_mpi <<" The BSpline Modeling Time is "<<seconds<<endl;
    
    if (error == cudaSuccess) {
       // cout << myrank_mpi << " generating BSpline done!"  << endl;
    } else {
       // cout << myrank_mpi << " generating BSpline failed!"  << endl;
        exit(0);
    }
    
    start = GetTime();
    
    array_size = nSelectedTrajNum * SAMPLE_NUM * DIMENSION;
    pTrajectory_B = new float[array_size];
    copy_from_cuda_array_float(trajectory_B, pTrajectory_B, array_size);
    
    array_size = nSelectedTrajNum * SAMPLE_NUM;
    pfSpeed = new float[array_size];
    copy_from_cuda_array_float(speed, pfSpeed, array_size);
    
    pfLength = new float[nSelectedTrajNum];
    array_size = nSelectedTrajNum;
    copy_from_cuda_array_float(length, pfLength, array_size);
    
    free_cuda_array_float(trajectory);
    trajectory = NULL;
    free_cuda_array_int(pointcount);
    pointcount = NULL;
    free_cuda_array_int(initialindex);
    initialindex = NULL;
    free_cuda_array_float(trajectory_B);
    trajectory_B = NULL;
    free_cuda_array_float(speed);
    speed = NULL;
    free_cuda_array_float(length);
    length = NULL;
    free_cuda_array_float(knots);
    knots = NULL;
    free_cuda_array_int(pointcount_K);
    pointcount_K = NULL;
    free_cuda_array_int(initialindex_K);
    initialindex_K = NULL;
    end = GetTime();
    seconds = end - start;
	
/////////////////////////////Calculate Line Length//////////////////// 
	MPI_Barrier(MPI_COMM_WORLD);	
  	if(gpiCount != NULL){
		delete []gpiCount;
		gpiCount = NULL;
	}

    gpiCount = new int[nprocs_mpi];

	MPI_Barrier(MPI_COMM_WORLD);
	send_count = recv_count = 1;
	MPI_Allgather(&nSelectedTrajNum, send_count, MPI_INT,
	              gpiCount, recv_count, MPI_INT, 
				  MPI_COMM_WORLD);
	MPI_Barrier(MPI_COMM_WORLD);	
	
    int currentpointer = 0;
	totallinenum = 0;
	for(int i = 0; i < nprocs_mpi; i++)
	{
		totallinenum += gpiCount[i];
	}
	
	if(myrank_mpi == 0)
	{
		sprintf(cFileName, "%s/Length.dat", OUT_PATH);
		outf.open(cFileName);
		assert(outf);
		outf<<totallinenum<<endl;
		outf.close();
	}
		
	for(int j = 0; j < nprocs_mpi; j++)
	{
		if(myrank_mpi == j)
		{
		sprintf(cFileName, "%s/Length.dat", OUT_PATH);
    	outf.open(cFileName, ios::out | ios::app);
    	//outf << linenum_to_read << " " << iTotalPointCount << " " 
        //	 << nSelectedTrajNum << endl;
		int currentpointer = 0;
		for(int i = 0; i < myrank_mpi; i++)
		{
			currentpointer += gpiCount[i];
		}
		//outf.write(reinterpret_cast<char*>(pfLength), 
		//			nSelectedTrajNum*sizeof(float));
    	for(int i = 0; i < nSelectedTrajNum; i ++) {
        	outf<<pfLength[i]<<endl;
    	}
		
    	outf.close();
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}
	
//////////////////////////Calculate Line Length////////////////////////
       
    if(pTrajectory_temp != NULL){
        delete []pTrajectory_temp;
        pTrajectory_temp = NULL;
    }
    if(pPointCount != NULL){
        delete []pPointCount;
        pPointCount = NULL;
    }
    if(pInitIndex != NULL){
        delete []pInitIndex;
        pInitIndex = NULL;
    }
    
    for(int i = 0; i< linenum_to_read; i++){
        if (pTrajectory_orig[i] != NULL){
            delete []pTrajectory_orig[i];
            pTrajectory_orig[i] = NULL;
        }
    }
    if(pTrajectory_orig != NULL){
        delete []pTrajectory_orig;
        pTrajectory_orig = NULL;
    }
    
    for(int i = 0; i< linenum_to_read; i++) {
        if (pTrajectory_sample[i] != NULL) {
            delete []pTrajectory_sample[i];
            pTrajectory_sample[i] = NULL;
        }
    }
    if(pTrajectory_sample != NULL){
        delete []pTrajectory_sample;
        pTrajectory_sample = NULL;
    }
    
    if(pTrajectory_B != NULL){
        delete []pTrajectory_B;
        pTrajectory_B = NULL;
    }
    
    if(pfSpeed != NULL){
        delete []pfSpeed;
        pfSpeed = NULL;
    }
    if(pTrajectory_temp != NULL){
        delete []pTrajectory_temp;
        pTrajectory_temp = NULL;
    }
    
    if(pfKnots != NULL){
        delete []pfKnots;
        pfKnots = NULL;
    }
    if(pfLength != NULL){
        delete []pfLength;
        pfLength = NULL;
    }
    if(pPointCount != NULL){
        delete []pPointCount;
        pPointCount = NULL;
    }
    if(pInitIndex != NULL){
        delete []pInitIndex;
        pInitIndex = NULL;
    }
    if(pPointCount_temp != NULL){
        delete []pPointCount_temp;
        pPointCount_temp = NULL;
    }
    if(pInitIndex_temp != NULL){
        delete []pInitIndex_temp;
        pInitIndex_temp = NULL;
    }
    if(pnPointCount_K != NULL){
        delete []pnPointCount_K;
        pnPointCount_K = NULL;
    }
    if(pnInitIndex_K != NULL){
        delete []pnInitIndex_K;
        pnInitIndex_K = NULL;
    }
	if(gpiCount != NULL){
		delete []gpiCount;
		gpiCount = NULL;
	}
	if(gpiCount1 != NULL){
		delete []gpiCount1;
		gpiCount1 = NULL;
	}
if(myrank_mpi == 0){
	cout<<"Preprocessing is done!"<<endl;
	}
//	MPI_Win_free(&countwin);        
    MPI_Finalize();
    return 0;
}
