#include <iostream>
#include <fstream>
#include <cassert>
#include <map>
#include <vector>
#include <algorithm>

#include "mpi.h"
#include "macro.h"

using namespace std;

struct sTrajIndex{
int group;
int order;
}; 

typedef multimap< int, sTrajIndex, less<int> > mm_len;
typedef multimap <int, int, less<int> > mm_rec;
typedef vector< sTrajIndex > v_index;
typedef vector< vector < sTrajIndex > > vv_index;

int main(int argc, char** argv){

int myrank_mpi, nprocs_mpi;
int linenum_to_read, iTotalPointCount, nSelectedTrajNum;
int InitIndex, PointCount;
struct sTrajIndex trajindex;
char cFileName[1000];
ifstream infile;
ofstream outfile;
mm_len pairs;
int print_id = 0;

MPI_Init(&argc, &argv);
MPI_Comm_rank(MPI_COMM_WORLD, &myrank_mpi);
MPI_Comm_size(MPI_COMM_WORLD, &nprocs_mpi);

for(int i = 0; i < nprocs_mpi; i++){
	sprintf(cFileName, "%s/DataHeader_%04d.txt", OUT_PATH, i);
	infile.open(cFileName);
	assert(infile);
	infile >> linenum_to_read >> iTotalPointCount >> nSelectedTrajNum;

	for(int j = 0; j < nSelectedTrajNum; j ++){
		infile >> InitIndex >> PointCount;
		trajindex.group = i;
		trajindex.order = j;
		pairs.insert(mm_len::value_type(PointCount, trajindex));
	}
	infile.close();
}

if(myrank_mpi == print_id){
sprintf(cFileName, "%s/testindex.txt", OUT_PATH);
outfile.open(cFileName);
assert(outfile);
	for (mm_len::const_iterator iter = pairs.begin(); 
		iter != pairs.end(); ++iter){
		outfile << iter -> first <<" "<< iter->second.group 
		<<" "<< iter->second.order<<endl;
	}
outfile.close();
}

v_index index_rec;
vv_index files;
vv_index::iterator vv_iter;
mm_rec computers;
mm_rec::iterator mm_iter_rec;

int temp_counter = 0;
int temp_counter1 = 0;
int iTotalWeight;
int iRecIndex;
int iMax, iMin;

for(int i = 0; i < nprocs_mpi; i++){
	computers.insert(mm_rec::value_type(0, i));
}

for(mm_len::reverse_iterator mm_iter = pairs.rbegin();
	mm_iter != pairs.rend(); ++mm_iter){

	mm_iter_rec = computers.begin();
	iTotalWeight = mm_iter_rec->first +  mm_iter->first;
	iRecIndex = mm_iter_rec->second;
	computers.erase(mm_iter_rec);
	computers.insert(mm_rec::value_type(iTotalWeight,iRecIndex));
	
	trajindex.group = mm_iter->second.group;
	trajindex.order = mm_iter->second.order;
		
	if(temp_counter < nprocs_mpi){
		index_rec.push_back(trajindex);
		files.push_back(index_rec);
		temp_counter ++;
	}
	else{
		files[iRecIndex].push_back(trajindex);
	}
		
	if(myrank_mpi == print_id){
		//if(temp_counter1 < 10)
		{
			temp_counter1 ++;
			cout << mm_iter->first<<" ";
			for(mm_rec::const_iterator mm_iter1 = computers.begin();
				mm_iter1 != computers.end(); ++mm_iter1){
				cout<<mm_iter1->first<<" ";
			}
		cout << endl;
		}
	}
}
	iMin = (computers.begin())->first;
	mm_iter_rec = computers.end();
	mm_iter_rec --;
	iMax = mm_iter_rec->first;
	cout<<iMin<<" "<<iMax<<endl;

MPI_Finalize();
return 0;
}
