#include <iostream>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <stdlib.h>

#include "mpi.h"
#include "macro.h"

#include "jsoncpp/json.h"
using namespace std;

struct sTrajIndex{
int group;
int order;
}; 

typedef multimap<float, int, less<float> > mm_len;
typedef multimap <float, int, less<float> > mm_rec;
typedef vector< int > v_index;
typedef vector< vector < int > > vv_index;
typedef set< int, less < int > > int_set;

int main(int argc, char** argv){
 int GROUPOFTRAJECTORY = 12;
 int direc = atoi(argv[1]);

  if(direc > 0)
        GROUPOFTRAJECTORY = atoi(argv[1]);
    else{
     bool alive = true;
        while (alive){
            Json::Value root;
            Json::Reader reader;
            std::ifstream test("../clusters.json", std::ifstream::binary);
            bool parsingSuccessful = reader.parse( test, root, false );
            if ( !parsingSuccessful ){
                std::cout  << reader.getFormatedErrorMessages() << "\n";}
            const Json::Value clusternum = root["ClusterNumber"];
            GROUPOFTRAJECTORY = clusternum.asInt();
         alive = false;
        }
    }
 //int GROUPOFTRAJECTORY = atoi(argv[1]); 
 //int GROUPOFTRAJECTORY = 10;   

int myrank_mpi, nprocs_mpi;
int linenum_to_read, linenum_to_write;
float line_length;
int trajindex;
char cFileName[1000];
char cFileName1[1000];
ifstream infile;
ifstream infile1;
ofstream outfile;
mm_len pairs;
int print_id = 3;

MPI_Init(&argc, &argv);
MPI_Comm_rank(MPI_COMM_WORLD, &myrank_mpi);
MPI_Comm_size(MPI_COMM_WORLD, &nprocs_mpi);

sprintf(cFileName1, "%s/IndexCount.txt", OUT_PATH);
infile1.open(cFileName1);
assert(infile1);

infile1>>linenum_to_read;

sprintf(cFileName, "%s/Length.dat", OUT_PATH);
infile.open(cFileName);
assert(infile);

infile>>linenum_to_read;
int initindex, countnum;
for(int j = 0; j < linenum_to_read; j ++){
	infile >> line_length;
	infile1 >> trajindex >> initindex >> countnum; 
//	trajindex = j;
	
	pairs.insert(mm_len::value_type(line_length, trajindex));
}

infile.close();
infile1.close();
/*if(myrank_mpi == print_id)
{
	sprintf(cFileName, "%s/testindex.txt", OUT_PATH);
	outfile.open(cFileName);
	assert(outfile);

	for(mm_len::const_iterator iter = pairs.begin();
		iter != pairs.end(); ++iter)
		{
			outfile<<iter->first<<" "<<iter->second<<endl;
		}
outfile.close();
}
*/

v_index index_rec;
vv_index files;
vv_index::iterator vv_iter;
mm_rec computers;
mm_rec::iterator mm_iter_rec;

int temp_counter = 0;
int temp_counter1 = 0;
int temp_counter2 = 0;
float iTotalWeight;
int iRecIndex;
int iMax, iMin;

for(mm_len::reverse_iterator mm_iter = pairs.rbegin();
	mm_iter != pairs.rend(); ++mm_iter){
	temp_counter2 ++;
	if(temp_counter < nprocs_mpi){
		iTotalWeight =  mm_iter->first;
		trajindex = mm_iter->second;
		
		computers.insert(mm_rec::value_type(iTotalWeight, temp_counter));
		index_rec.clear();
		index_rec.push_back(trajindex);
		files.push_back(index_rec);
		temp_counter++;
	}
	else{

		mm_iter_rec = computers.begin();
		iTotalWeight = mm_iter_rec->first +  mm_iter->first;
		iRecIndex = mm_iter_rec->second;
		trajindex = mm_iter->second;
		computers.erase(mm_iter_rec);
		computers.insert(mm_rec::value_type(iTotalWeight,iRecIndex));
	
		(files[iRecIndex]).push_back(trajindex);
	}
		
	if(myrank_mpi == print_id){
		if(temp_counter1 < 10)
		{
			temp_counter1 ++;
		//	cout << mm_iter->first<<" ";
			for(mm_rec::const_iterator mm_iter1 = computers.begin();
				mm_iter1 != computers.end(); ++mm_iter1){
	//			cout<<mm_iter1->second<<endl;
			}
	//	cout << endl;
		}
	}
}

int_set sorting;

sprintf(cFileName, "%s/index%04d.txt", OUT_PATH, myrank_mpi);
outfile.open(cFileName);
assert(outfile);

linenum_to_write = files[myrank_mpi].size();
//cout<<linenum_to_write<<endl;
outfile<<linenum_to_write<<endl;
//outfile.write(reinterpret_cast<char*>(&linenum_to_write), sizeof(int));

for(int i = 0; i < files[myrank_mpi].size();i++)
{
	sorting.insert(files[myrank_mpi][i]);
}
for(int_set::const_iterator iter = sorting.begin(); 
iter != sorting.end(); iter++)
{
	//outfile.write(reinterpret_cast<char*>(&files[myrank_mpi]), sizeof(int));
	//outfile<<files[myrank_mpi][i]<<endl;
	outfile<<*iter<<endl;
}

outfile.close();
if(myrank_mpi == 0)
{
	cout<<"The matrix allocation is done!"<<endl;
}
MPI_Finalize();
return 0;
}
