#include "mpi.h"
#include <iostream>
#include <fstream>
#include <assert.h>
#include <sys/time.h>
#include <vector>
#include <stdlib.h>

#include "BSpline.h"
#include "macro.h"
#include "float.h"
#include "time.h"
#include "cxgl.h"

#include "jsoncpp/json.h"
using namespace std;

double GetTime()
{
   //struct timeval start;
   //gettimeofday(&start, 0);
    
   //double seconds = start.tv_sec + start.tv_usec * 1e-6;
   //return seconds;
   double seconds;
   seconds = MPI_Wtime();
   return seconds;
}

int iDivUp(int a, int b)
{
    return (a % b != 0) ? (a / b + 1) : (a / b);
}

int main(int argc, char** argv)
{
 int GROUPOFTRAJECTORY = 12;
 int direc = atoi(argv[1]);

  if(direc > 0)
        GROUPOFTRAJECTORY = atoi(argv[1]);
    else{
     bool alive = true;
        while (alive){
            Json::Value root;
            Json::Reader reader;
            std::ifstream test("../clusters.json", std::ifstream::binary);
            bool parsingSuccessful = reader.parse( test, root, false );
            if ( !parsingSuccessful ){
                std::cout  << reader.getFormatedErrorMessages() << "\n";}
            const Json::Value clusternum = root["ClusterNumber"];
            GROUPOFTRAJECTORY = clusternum.asInt();
         alive = false;
        }
    } 
 //int GROUPOFTRAJECTORY = atoi(argv[1]); 
  // int GROUPOFTRAJECTORY = 10; 
    ifstream infile, infile1;
    ofstream outf;
    char cFileName[1000];
    
    /*Information maintianed for trajectories*/
    float **pTrajectory_orig = NULL;
    
    //trajectory parameters: trajectories in arrays, original or sampled
    float **pTrajectory_sample = NULL;
    float *pTrajectory_temp = NULL;
    float *pAngle_temp = NULL;
    float *pTorsion_temp = NULL;
    float *pTrajectory_B = NULL;
    
    //trajectory parameters: rearranged trajectories in one array
    float *pfSpeed = NULL;
    int   *pPointCount = NULL;
    int   *pInitIndex = NULL;
    //used when filtering
    int   *pPointCount_temp = NULL; 
    //used when filtering
    int   *pInitIndex_temp = NULL;
    //trajectory parameters: point number and initial point initial index of each trajectory
    unsigned long iTotalPointCount;
    // the length of each trajectory after normalization
    float *pfLength = NULL ;    
    /*Information maintianed for trajectories*/
    
    /*BSpline Knots*/
    float *pfKnots = NULL;
    int   *pnPointCount_K = NULL;
    int   *pnInitIndex_K = NULL;
    /*BSpline Knots*/
    
    /*The corresponding trajectory information on GPU*/
    float *trajectory = NULL;
    float *trajectory_B = NULL;
    float *trajectory_B_sampled = NULL;
    float *knots = NULL;
    float *length = NULL;
    float *speed = NULL;//GPU input trajectory
    int   *initialindex = NULL;
    int   *pointcount = NULL;
    int   *initialindex_K = NULL;
    int   *pointcount_K = NULL;//GPU trajectory information
    float *percentage = NULL;
    /*The corresponding trajectory information on GPU*/
    
    /*For EM algorithm and other temporal variables*/
    int     nMaxPointCount, nSelectedTrajNum;
    float   a, b;
    float   scale_v[DIMENSION];
    float   Max_mv[DIMENSION], Min_mv[DIMENSION];
    float   *Max_v[DIMENSION], *Min_v[DIMENSION];
    /*For EM algorithm and other temporal variables*/
    
    int iPointCount;
    int linenum, linenum_to_read, line_start;
	int group_line_num, total_line_num;    
    int myrank_mpi, nprocs_mpi;

    int* gpiCount = NULL;
    int send_count, recv_count;
	//MPI_Aint* local_displacement = NULL;
	//int* total_displacement = NULL;
	//int* local_pointcount = NULL;
	//int* total_pointcount = NULL;
	int* index = NULL;
	float* pfTrajectory_mpi = NULL;
    ///////////////////////////////////////////////////////////
    double start, end, seconds;
    ///////////////////////////////////////////////////////////
    //MPI_Win countwin;
    //MPI_File thefile;
    //MPI_Datatype mytype;
	//MPI_Datatype *datatype = NULL;

	//////////////////////////////////////////////////////////
    cudaError_t error;
        
    MPI_Init( &argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &myrank_mpi);
    MPI_Comm_size(MPI_COMM_WORLD, &nprocs_mpi);
    
    iTotalPointCount = 0;
    nMaxPointCount = -INT_MAX;
   
    /*sprintf(cFileName, "%s/IndexCount.txt", OUT_PATH);
	infile1.open(cFileName);
	assert(infile1);
	
	infile1>>total_line_num;

	total_displacement = new int[total_line_num];
	total_pointcount = new int[total_line_num];
	
	int temp_line_index;
	for(int i = 0; i < total_line_num; i++)
	{
		infile1>>temp_line_index>>total_displacement[i]
				>>total_pointcount[i];
	}
 
	infile1.close();
*/
    sprintf(cFileName, "%s/index%04d.txt", OUT_PATH, myrank_mpi);
    infile.open(cFileName);
    assert(infile);
    infile>>group_line_num;
    index = new int[group_line_num];
//	local_displacement = new MPI_Aint[group_line_num];
//	local_pointcount = new int[group_line_num];
//	datatype = new MPI_Datatype[group_line_num];

	int temp_local_pointnum = 0;

    for(int i = 0; i < group_line_num; i++)
    {
		infile>>index[i];
//		local_displacement[i] = MPI_Aint(total_displacement[index[i]]
//		*sizeof(float));
//		local_pointcount[i] = total_pointcount[index[i]];
//		temp_local_pointnum += local_pointcount[i];
//		datatype[i] = MPI_FLOAT;
    }
	
    infile.close();
	
/*	if(total_displacement != NULL){
		delete []total_displacement;
		total_displacement = NULL;
	}
	
	if(total_pointcount != NULL){
		dlete []total_pointcount;
		total_pointcount = NULL;
	}
*/
//////////////////////read data using struct view//////////////////////////
/*	pfTrajectory_mpi = new float[temp_local_pointnum];
	MPI_File_open(MPI_COMM_WORLD, DAT_FILE, 
				  MPI_MODE_RDONLY, 
				  MPI_INFO_NULL, &thefile);
	
	MPI_Type_create_struct(group_line_num, local_pointcount, 
						local_displacement, datatype, &mytype);
	

	MPI_Type_commit(&mytype);

	MPI_File_set_view(thefile, 0, MPI_FLOAT,
					  mytype, "native", MPI_INFO_NULL);
	
	MPI_File_read_all(thefile, pfTrajectory_mpi, temp_local_pointnum, 
				MPI_FLOAT, MPI_STATUS_IGNORE);

	MPI_File_close(&thefile);
	MPI_Barrier(MPI_COMM_WORLD);
*/
////////////////////read data using struct view///////////////////////////
    char filename[] = DAT_FILE;
    ifstream inf(filename, ios::binary);
    assert(inf);
        
    // read line data
    inf.read(reinterpret_cast<char*>(&linenum), sizeof(int));
    
    linenum_to_read = group_line_num;
    pTrajectory_orig    = new float*[linenum_to_read];
    pTrajectory_sample  = new float*[linenum_to_read];
    pPointCount         = new int[linenum_to_read];
    pInitIndex          = new int[linenum_to_read];
    pPointCount_temp    = new int[linenum_to_read];
    pInitIndex_temp     = new int[linenum_to_read];
    nMaxPointCount      = 0;
    
    int readnum = 0;
    for (int i = 0; i < linenum; i++) {
        
        cxLine *line = new cxLine;
        line->Read(inf);
                
	   if(i != index[readnum])
	   {
	   	delete line;
		continue;
	   }

        vector<cxLinePoint> &para_line = line->GetParaLine();
        
        iPointCount = para_line.size();
        
        pInitIndex[readnum] = iTotalPointCount;
        pPointCount[readnum] = iPointCount;
        
        iTotalPointCount += iPointCount;
        
        if (nMaxPointCount < iPointCount) {
            nMaxPointCount = iPointCount;
        }
        
        pTrajectory_orig[readnum] = new float[iPointCount*DIMENSION];
        
        for (int j = 0; j < para_line.size(); j++) {
            for (int d = 0; d < DIMENSION; d++) {
                pTrajectory_orig[readnum][j*DIMENSION+d] = (para_line[j].Pos())[d];
			}
        }

		//cout<<linenum<<" "<<para_line.size()<<endl;
        
        delete line;
        
        readnum++;
        if (readnum >= linenum_to_read) {
            break;
        }
    }

    inf.close();    
    
	iTotalPointCount = 0;
    iPointCount = 0;
    
    for (int d = 0; d < DIMENSION; d++) {
        Max_v[d] = new float[linenum_to_read];
        Min_v[d] = new float[linenum_to_read];
    }
    
    for (int i = 0; i < linenum_to_read; i++){                
        
        for (int d = 0; d < DIMENSION; d++) {
            Max_v[d][i] = -FLT_MAX;
            Min_v[d][i] = FLT_MAX;
        }
        
        pInitIndex[i]          = iTotalPointCount;
        pPointCount[i]         = int(pPointCount[i]/SAMPLE_STEP);        
        pInitIndex_temp[i]     = pInitIndex[i];
        pPointCount_temp[i]    = pPointCount[i];
        iTotalPointCount      += pPointCount[i];
        pTrajectory_sample[i]  = new float[pPointCount[i]*DIMENSION];
        
        for(int j = 0; j < pPointCount[i]; j++) {            
            for (int d = 0; d < DIMENSION; d++) {
                pTrajectory_sample[i][j * DIMENSION + d] 
                    = pTrajectory_orig[i][j * SAMPLE_STEP * DIMENSION + d];
                
                if (Max_v[d][i] < pTrajectory_sample[i][j*DIMENSION + d]) {
                    Max_v[d][i] = pTrajectory_sample[i][j*DIMENSION + d];
                }
                
                if (Min_v[d][i] > pTrajectory_sample[i][j*DIMENSION + d]) {
                    Min_v[d][i] = pTrajectory_sample[i][j*DIMENSION + d];
                }
            }
        }
    }
    
    for (int d = 0; d < DIMENSION; d++) {
        Max_mv[d] = -FLT_MAX;
        Min_mv[d] = FLT_MAX;
    }    
    
    for (int i = 0; i < linenum_to_read; i ++)
    {
        for (int d = 0; d < DIMENSION; d++) 
        {
            if (Max_mv[d] < Max_v[d][i]) {
                Max_mv[d] = Max_v[d][i];
            }
            if (Min_mv[d] > Min_v[d][i]) {
                Min_mv[d] = Min_v[d][i];
            }
        }
    }
    
    for (int d = 0; d < DIMENSION; d++) {        
        scale_v[d] = Max_mv[d] - Min_mv[d];
    }
    
    iTotalPointCount = 0;
    nSelectedTrajNum = 0;
    /////////////////////Rearrange trajectories////////////////////////////
    //sprintf(cFileName, "%s/Selected_%04d.txt", OUT_PATH, myrank_mpi);    
    //outf.open(cFileName);    
    for(int i = 0; i < linenum_to_read; i ++) {
        bool passed = true;
        /*for (int d = 0; d < DIMENSION; d++) {
            if ((Max_v[d][i] - Min_v[d][i]) < scale_v[d] * THRESHOLD ||
                pPointCount_temp[i] < 5) 
            {
                passed = false;
                break;
            }        
        } 
		*/
        if (passed) {
            iTotalPointCount += pPointCount[i];
            //outf<<i<<endl;
            nSelectedTrajNum ++;
        }
    }
    
    //outf.close();    
    //cout<<"The Selected Trajectory Number is "<< nSelectedTrajNum<<endl;
    
    if(pPointCount != NULL) {
        delete []pPointCount;
        pPointCount = NULL;
    }
    pPointCount  = new int[nSelectedTrajNum];
    
    if(pInitIndex != NULL) {
        delete []pInitIndex;
        pInitIndex = NULL;
    }    
    pInitIndex  = new int[nSelectedTrajNum];
    
    int temp = 0;
    iTotalPointCount = 0;
    
    for(int i = 0; i < linenum_to_read; i ++) {
        bool passed = true;
        /*for (int d = 0; d < DIMENSION; d++) {
            if ((Max_v[d][i] - Min_v[d][i]) < scale_v[d] * THRESHOLD ||
                pPointCount_temp[i] < 5) 
            {
                passed = false;
                break;
            }        
        } 
        */
        if (passed) {
            pPointCount[temp] = pPointCount_temp[i];
            pInitIndex[temp]  = iTotalPointCount;
            iTotalPointCount += pPointCount_temp[i];
            temp = temp + 1;
        }
    }
    
    pTrajectory_temp = new float[iTotalPointCount*DIMENSION];
    temp = 0;
    
	//Not worth working on GPU
    for (int i = 0; i < linenum_to_read; i ++) 
    {
        bool passed = true;
        /*for (int d = 0; d < DIMENSION; d++) {
            if ((Max_v[d][i] - Min_v[d][i]) < scale_v[d] * THRESHOLD ||
               pPointCount_temp[i] < 5) 
            {
                passed = false;
                break;
            }        
        }
        */
        if(passed)
        {
		
            for (int j = 0; j < pPointCount_temp[i]; j++)
            {
                for (int d = 0; d < DIMENSION; d++) 
                {
                    //normalization
                    pTrajectory_temp[d*iTotalPointCount + pInitIndex[temp] + j] = (pTrajectory_sample[i][j*DIMENSION + d] - Min_mv[d])/scale_v[d];
                
				}
            }            
            temp++;

        }
    }
    pfKnots = new float[iTotalPointCount+nSelectedTrajNum*(BSPLINE_DEGREE + 1)];
    pnInitIndex_K = new int[nSelectedTrajNum];
    pnPointCount_K = new int[nSelectedTrajNum];
    int totalknotpoint = 0;
    int knotnum = 0;
    int m_numCP;
        
    for(int n = 0; n < nSelectedTrajNum; n++)
    {
        m_numCP = pPointCount[n];
        pnInitIndex_K[n] = totalknotpoint;
        knotnum = m_numCP + BSPLINE_DEGREE + 1;
        pnPointCount_K[n] = knotnum;
        
        for (int i = 0; i <= BSPLINE_DEGREE; i++) {
            pfKnots[totalknotpoint + i] = 0.0;
            pfKnots[totalknotpoint + knotnum- i - 1] = 1.0;
        }
        
        float delta = 1.0/(m_numCP - BSPLINE_DEGREE);
        for (int j = 1; j <= m_numCP - BSPLINE_DEGREE -1; j++) {            
            pfKnots[totalknotpoint + j + BSPLINE_DEGREE] = delta*j;            
        }
        
        totalknotpoint += knotnum;
    }
    
    start = GetTime();

	
    /////////////////GPU BSpline Generation////////////////////
    int array_size = iTotalPointCount * DIMENSION;
    create_cuda_array_float(&trajectory, array_size);
    copy_to_cuda_array_float(trajectory, pTrajectory_temp, array_size);
    
	array_size = nSelectedTrajNum;
    create_cuda_array_int(&pointcount, array_size);
    copy_to_cuda_array_int(pointcount, pPointCount, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_int(&initialindex, array_size);
    copy_to_cuda_array_int(initialindex, pInitIndex, array_size);
    
    array_size = nSelectedTrajNum * SAMPLE_NUM * DIMENSION;
    create_cuda_array_float(&trajectory_B, array_size);
    
    array_size = nSelectedTrajNum * SAMPLE_NUM ;
    create_cuda_array_float(&speed, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_float(&length, array_size);
    
    array_size = totalknotpoint;
    create_cuda_array_float(&knots, array_size);
    copy_to_cuda_array_float(knots, pfKnots, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_int(&pointcount_K, array_size);
    copy_to_cuda_array_int(pointcount_K, pnPointCount_K, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_int(&initialindex_K, array_size);
    copy_to_cuda_array_int(initialindex_K, pnInitIndex_K, array_size);
    
    end = GetTime();
    double transferin_time = end - start;
  //  cout<<myrank_mpi<<" The Data Transmition(to GPU) Time 1 is "<<seconds<<endl;
   // cout << myrank_mpi << " generating BSpline start!"  << endl;
    start = GetTime();
    int nGridSize = iDivUp(nSelectedTrajNum, BLOCK_SIZE);
	if(DIMENSION == 2){
    	CUDA_genBSpline2D(nGridSize, BLOCK_SIZE, trajectory, pointcount, initialindex, knots, pointcount_K, initialindex_K, trajectory_B, speed, length, nSelectedTrajNum, iTotalPointCount, BSPLINE_DEGREE, SAMPLE_NUM, nSelectedTrajNum);
	} 
	if(DIMENSION == 3){
    	CUDA_genBSpline3D(nGridSize, BLOCK_SIZE, trajectory, pointcount, initialindex, knots, pointcount_K, initialindex_K, trajectory_B, speed, length, nSelectedTrajNum, iTotalPointCount, BSPLINE_DEGREE, SAMPLE_NUM, nSelectedTrajNum);
	}   
	// end = GetTime();
    //double modeltime = end - start;
      
    error = cudaThreadSynchronize();
    
   	 end = GetTime();
    double modeltime = end - start;
    cout<< myrank_mpi << " Modeling time is "<<modeltime; 


    if (error == cudaSuccess) {
     //   cout << myrank_mpi << " generating BSpline done!"  << endl;
    } else {
     //   cout << myrank_mpi << " generating BSpline failed!"  << endl;
        exit(0);
    }
    
    start = GetTime();
    
    array_size = nSelectedTrajNum * SAMPLE_NUM * DIMENSION;
    pTrajectory_B = new float[array_size];
    copy_from_cuda_array_float(trajectory_B, pTrajectory_B, array_size);
    
    array_size = nSelectedTrajNum * SAMPLE_NUM;
    pfSpeed = new float[array_size];
    copy_from_cuda_array_float(speed, pfSpeed, array_size);
    
    pfLength = new float[nSelectedTrajNum];
	assert(pfLength);
    array_size = nSelectedTrajNum;
    copy_from_cuda_array_float(length, pfLength, array_size);
   	    
	free_cuda_array_float(trajectory);
    trajectory = NULL;
    free_cuda_array_int(pointcount);
    pointcount = NULL;
    free_cuda_array_int(initialindex);
    initialindex = NULL;
    free_cuda_array_float(trajectory_B);
    trajectory_B = NULL;
    free_cuda_array_float(speed);
    speed = NULL;
    free_cuda_array_float(length);
    length = NULL;
    free_cuda_array_float(knots);
    knots = NULL;
    free_cuda_array_int(pointcount_K);
    pointcount_K = NULL;
    free_cuda_array_int(initialindex_K);
    initialindex_K = NULL;
    end = GetTime();
    seconds = end - start;
 
 	/*ofstream outf_temp;
	char file_name_temp[1000];
	for(int i = 0; i < nSelectedTrajNum; i ++)
	{
		sprintf(file_name_temp, "speed%d.txt", i);
		outf_temp.open(file_name_temp);
		for(int j = 0; j < SAMPLE_NUM; j ++)
		{
			outf_temp<<pfSpeed[i*SAMPLE_NUM+j]<<endl;
		}
		outf_temp.close();
	}
	*/
//	cout<<myrank_mpi<<" The Data Transmission Time(from GPU) Time 1 is "<<seconds<<endl;
    
    int iTotalPointCount_orig = iTotalPointCount;
    iTotalPointCount = 0;
    for(int i = 0; i < nSelectedTrajNum; i++){
        pInitIndex[i] = iTotalPointCount;
        pPointCount[i] = int(pfLength[i]/LENGTH_INTERVAL);
        
		if (pPointCount[i] == 0) {
			cout<< myrank_mpi<<endl;
            cerr << "can not be zero" << endl;
            exit(0);
        }
        iTotalPointCount += pPointCount[i];
		if ((myrank_mpi == 0)){
			//cout<<pfLength[i]<<endl;
		}
    }
    
    if(pTrajectory_temp != NULL){
        delete []pTrajectory_temp;
        pTrajectory_temp = NULL;
    }
    
   cout<<"The Sampled total points are "<<iTotalPointCount<<" and the line number is "<<nSelectedTrajNum<<endl; 
    start = GetTime();
    array_size = iTotalPointCount * DIMENSION;
    create_cuda_array_float(&trajectory_B_sampled, array_size);
    
   cout<<"rank "<<myrank_mpi<<" "<<nSelectedTrajNum<<" "<<iTotalPointCount<<endl; 
    array_size = nSelectedTrajNum * SAMPLE_NUM * DIMENSION;
    create_cuda_array_float(&trajectory_B, array_size);
    copy_to_cuda_array_float(trajectory_B, pTrajectory_B, array_size);
    
    array_size = nSelectedTrajNum * SAMPLE_NUM ;
    create_cuda_array_float(&speed, array_size);
    copy_to_cuda_array_float(speed, pfSpeed, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_float(&length, array_size);
    copy_to_cuda_array_float(length, pfLength, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_int(&pointcount, array_size);
    copy_to_cuda_array_int(pointcount, pPointCount, array_size);
    
    array_size = nSelectedTrajNum;
    create_cuda_array_int(&initialindex, array_size);
    copy_to_cuda_array_int(initialindex, pInitIndex, array_size);
    
    array_size = nSelectedTrajNum * SAMPLE_NUM;
    create_cuda_array_float(&percentage, array_size);
    
    end = GetTime();
    seconds = end - start;
    start = GetTime();
    
    // cout<<"The BSpline Transmission(to GPU) Time 2 is "<<seconds<<endl;
    
    //cerr << myrank_mpi << " reparameterizing start!" << endl;
    
    nGridSize = iDivUp(nSelectedTrajNum, BLOCK_SIZE);

    CUDA_reParameter(nGridSize, BLOCK_SIZE, trajectory_B, speed, length,
                      pointcount, percentage, initialindex,
                      trajectory_B_sampled, iTotalPointCount,
                      SAMPLE_NUM * nSelectedTrajNum,
                      nSelectedTrajNum, SAMPLE_NUM,
                      nSelectedTrajNum);
    
    //end = GetTime();
    //double reparatime = end - start;
    
    
    error = cudaThreadSynchronize();
    end = GetTime();
    double reparatime = end - start;
   cout<< myrank_mpi << " reparameterizing time is "<<reparatime; 

    if (error == cudaSuccess) {
       // cout << myrank_mpi << " reparameterizing done!" << endl;
    } else {
       // cerr << myrank_mpi << " reparameterizing failed!" << endl;
        exit(0);
    }
    
    
    //cout<<iTotalPointCount<<endl;
    
    start = GetTime();
    pTrajectory_temp = new float[iTotalPointCount*DIMENSION];
    array_size = iTotalPointCount*DIMENSION;
    
    copy_from_cuda_array_float(trajectory_B_sampled, pTrajectory_temp, 
                               array_size);
    end = GetTime();
    double transferout_time = end - start;
     
    free_cuda_array_float(trajectory_B_sampled);
    free_cuda_array_int(pointcount);
    free_cuda_array_int(initialindex);
    free_cuda_array_float(trajectory_B);
    free_cuda_array_float(speed);
    free_cuda_array_float(length);
    free_cuda_array_float(percentage);
    
   // cout<<"The Data Transmission(from GPU) Time 2 is "<<seconds<<endl;
    double Allmodeltime[nprocs_mpi];
    double Allreparatime[nprocs_mpi];
    double Alltransferin_time[nprocs_mpi];
	double Alltransferout_time[nprocs_mpi];

    MPI_Barrier(MPI_COMM_WORLD);
    MPI_Allgather(&modeltime, 1, MPI_DOUBLE,
                  Allmodeltime, 1, MPI_DOUBLE,
                  MPI_COMM_WORLD);
    MPI_Barrier(MPI_COMM_WORLD);
    MPI_Allgather(&reparatime, 1, MPI_DOUBLE,
                  Allreparatime, 1, MPI_DOUBLE,
                  MPI_COMM_WORLD);
    MPI_Barrier(MPI_COMM_WORLD);
    MPI_Allgather(&transferin_time, 1, MPI_DOUBLE,
                  Alltransferin_time, 1, MPI_DOUBLE,
                  MPI_COMM_WORLD);
    MPI_Barrier(MPI_COMM_WORLD);
    MPI_Allgather(&transferout_time, 1, MPI_DOUBLE,
                  Alltransferout_time, 1, MPI_DOUBLE,
                  MPI_COMM_WORLD);



    if(0 == myrank_mpi){
        sprintf(cFileName,"%s/TrajTiming%04d.txt",OUT_PATH,nprocs_mpi);
        outf.open(cFileName);
        assert(outf);
        for(int i = 0; i < nprocs_mpi; i ++){
            outf<<i<<" "<<Allmodeltime[i]<<" "<<Allreparatime[i]<<" "<<Alltransferin_time[i]<<" "<<Alltransferout_time[i]<<endl;
        }
        outf.close();
    }

 
    for(int i = 0; i < iTotalPointCount; i++) {
        for (int d = 0; d < DIMENSION; d++) {
            pTrajectory_temp[iTotalPointCount * d + i]                 
                = pTrajectory_temp[iTotalPointCount *d + i] * scale_v[d] 
                + Min_mv[d];		
				}
        }
    
	if(gpiCount != NULL)
	{
		delete []gpiCount;
		gpiCount = NULL;
	}
    gpiCount = new int[nprocs_mpi];
	
	MPI_Barrier(MPI_COMM_WORLD);
	send_count = recv_count = 1;
	MPI_Allgather(&iTotalPointCount, send_count, MPI_INT,
	              gpiCount, recv_count, MPI_INT, 
				  MPI_COMM_WORLD);

/*	gpiCount = new int[nprocs_mpi];
	gpiCount[myrank_mpi] = iTotalPointCount;

	if(myrank_mpi == 0)
   	{
   		MPI_Win_create(gpiCount, sizeof(int), nprocs_mpi, MPI_INFO_NULL,
						MPI_COMM_WORLD, &countwin);	
   	}
	else
	{
		MPI_Win_create(MPI_BOTTOM, 0, 1, MPI_INFO_NULL, MPI_COMM_WORLD,
						&countwin);
	}

	MPI_Win_fence(0, countwin);
	if(myrank_mpi != 0)
	{
		MPI_Put(gpiCount + myrank_mpi, 1, MPI_INT, 0, myrank_mpi, 1, 
				MPI_INT, countwin); 
	}
	MPI_Win_fence(0, countwin);

	if(myrank_mpi == 0)
	{
		for (int i = 0; i < nprocs_mpi; i++)
		{
			cout<<gpiCount[i]<<" ";
		}
		cout<<endl;
	}
	MPI_Win_fence(0, countwin);
	if(myrank_mpi != 0)
	{
		MPI_Get(&gpiCount, nprocs_mpi, MPI_INT, 0, 0, nprocs_mpi, MPI_INT, 
				countwin);
	}	
	MPI_Win_fence(0, countwin);
*/
/*	sprintf(cFileName, "%s/DataHeader.txt", OUT_PATH);
	MPI_File_open(MPI_COMM_WORLD, cFileName, 
				  MPI_MODE_CREATE | MPI_MODE_WRONLY
				  MPI_INFO_NULL, &thefile);

	int currentpointer = 0;
	for(int i = 0; i < myrank_mpi; i++)
	{
		currentpoint += gpiCount[i];
	}

	MPI_File_set_view(thefile, currentpoint*sizeof(int), MPI_INT, MPI_INT,
					  "native", MPI_INFO_NULL);
	MPI_File_write(thefile, );
	MPI_File_close(&thefile);


    	sprintf(cFileName, "%s/TDimension.dat", OUT_PATH);
    	outf.open(cFileName, ios::out | ios::app | ios::binary);
    	outf.write(reinterpret_cast<char *>(pTrajectory_temp),
               sizeof(float) * (iTotalPointCount * DIMENSION));
    	outf.close();
    
    	sprintf(cFileName, "%s/test_sampled.line", OUT_PATH);
    	outf.open(cFileName, ios::out | ios::app);
    	outf.write(reinterpret_cast<char *>(&nSelectedTrajNum), 
					sizeof(int));
    	float pnt[DIMENSION];    
    	for(int i = 0; i < nSelectedTrajNum; i ++) {
        	int offset = pInitIndex[i];
        	int count = pPointCount[i];
        	cxLine *line = new cxLine;
        	for (int p = 0; p < count; p++) {
            	for (int d = 0; d < DIMENSION; d++) {
                	pnt[d] = pTrajectory_temp[d * iTotalPointCount
												+ offset + p];
            	}
                
            	if (DIMENSION == 2) {
                	line->PushBackPara(cxLinePoint(cx3DVector(pnt[0], 
													pnt[1], 0)));
            	} else if (DIMENSION == 3) {
               		line->PushBackPara(cxLinePoint(cx3DVector(pnt[0], 
													pnt[1], pnt[2])));
            	}
        	}
        	line->Write(outf);
    	}
    	outf.close();
	    cout << myrank_mpi << " writing done!" << endl;
	
	
	
	
	for(int j = 0; j < nprocs_mpi; j++)
	{
		if(myrank_mpi == j)
		{
		sprintf(cFileName, "%s/DataHeader.txt", OUT_PATH);
    	outf.open(cFileName, ios::out | ios::app);
    	//outf << linenum_to_read << " " << iTotalPointCount << " " 
        //	 << nSelectedTrajNum << endl;
    	int currentpointer = 0;
		for(int i = 0; i < myrank_mpi; i++)
		{
			currentpointer += gpiCount[i];
			cout<<gpiCount[i]<<" ";
		}
		cout<<endl;
		cout<<myrank_mpi<<" "<< currentpointer<<endl;
    	for(int i = 0; i < nSelectedTrajNum; i ++) {
        	outf<<pInitIndex[i]+currentpointer<<" "<<pPointCount[i]<<endl;
    	}

    	outf.close();
		}
		MPI_Barrier(MPI_COMM_WORLD);
	}*/
    sprintf(cFileName, "%s/DataHeader_%04d.txt", OUT_PATH, myrank_mpi);
    outf.open(cFileName);
    outf << linenum_to_read << " " << iTotalPointCount << " " 
         << nSelectedTrajNum << endl;
    
    for(int i = 0; i < nSelectedTrajNum; i ++) {
        outf<<pInitIndex[i]<<" "<<pPointCount[i]<<endl;
    }
    outf.close();
    
    sprintf(cFileName, "%s/TDimension_%04d.dat", OUT_PATH, myrank_mpi);
    outf.open(cFileName, ios::binary);
    outf.write(reinterpret_cast<char *>(pTrajectory_temp),
               sizeof(float) * (iTotalPointCount * DIMENSION));
    outf.close();
    
	sprintf(cFileName, "%s/test_sampled_%04d.line", OUT_PATH, myrank_mpi);
    outf.open(cFileName);
    outf.write(reinterpret_cast<char *>(&nSelectedTrajNum), sizeof(int));
	outf.write(reinterpret_cast<char *>(&iTotalPointCount), sizeof(int));
    float pnt[DIMENSION];    
    for(int i = 0; i < nSelectedTrajNum; i ++) {
//	char filename_temp[1000];
//	ofstream outfile;
//	sprintf(filename_temp, "%s/testline_%d_%d.tex", OUT_PATH, myrank_mpi,i);
//	outfile.open(filename_temp);
//	assert(outfile);
        int offset = pInitIndex[i];
        int count = pPointCount[i];
        cxLine *line = new cxLine;
        for (int p = 0; p < count; p++) {
            for (int d = 0; d < DIMENSION; d++) {
                pnt[d] = pTrajectory_temp[d * iTotalPointCount + offset + p];
            }
                
            if (DIMENSION == 2) {
				//outfile<<pnt[0]<<" "<<pnt[1]<<endl;
                line->PushBackPara(cxLinePoint(cx3DVector(pnt[0], pnt[1], 0)));
            } else if (DIMENSION == 3) {
                line->PushBackPara(cxLinePoint(cx3DVector(pnt[0], pnt[1], pnt[2])));
            }
        }
        line->Write(outf);

//	outfile.close();
    }
    outf.close();

    //cout << myrank_mpi << " writing done!" << endl;
    
    iTotalPointCount = 0;
    nSelectedTrajNum = 0;
//     sprintf(cFileName, "data/DataHeader_%04d.txt", myrank_mpi);
//     infile.open(cFileName);
//     infile >> linenum_to_read >> iTotalPointCount >> nSelectedTrajNum;
//     if(pTrajectory_temp == NULL){
//         pTrajectory_temp = new float[iTotalPointCount * DIMENSION];
//     }
//     if(pPointCount == NULL){
//         pPointCount = new int[nSelectedTrajNum];
//     }
//     if(pInitIndex == NULL){
//         pInitIndex = new int[nSelectedTrajNum];
//     }
//     
//     for(int i = 0; i < nSelectedTrajNum; i ++){
//         infile>>pInitIndex[i]>>pPointCount[i];
//     }
//     infile.close();
//     
//     sprintf(cFileName, "data/TDimension_%04d.dat", myrank_mpi);
//     infile.open(cFileName, ios::binary);
//     infile.read(reinterpret_cast<char *>(pTrajectory_temp), 
//                 sizeof(float) * (iTotalPointCount * DIMENSION));
//     infile.close();
    
    
    if(pTrajectory_temp != NULL){
        delete []pTrajectory_temp;
        pTrajectory_temp = NULL;
    }
    if(pPointCount != NULL){
        delete []pPointCount;
        pPointCount = NULL;
    }
    if(pInitIndex != NULL){
        delete []pInitIndex;
        pInitIndex = NULL;
    }
    
    for(int i = 0; i< linenum_to_read; i++){
        if (pTrajectory_orig[i] != NULL){
            delete []pTrajectory_orig[i];
            pTrajectory_orig[i] = NULL;
        }
    }
    if(pTrajectory_orig != NULL){
        delete []pTrajectory_orig;
        pTrajectory_orig = NULL;
    }
    
    for(int i = 0; i< linenum_to_read; i++) {
        if (pTrajectory_sample[i] != NULL) {
            delete []pTrajectory_sample[i];
            pTrajectory_sample[i] = NULL;
        }
    }
    if(pTrajectory_sample != NULL){
        delete []pTrajectory_sample;
        pTrajectory_sample = NULL;
    }
    
    if(pTrajectory_B != NULL){
        delete []pTrajectory_B;
        pTrajectory_B = NULL;
    }
    
    if(pfSpeed != NULL){
        delete []pfSpeed;
        pfSpeed = NULL;
    }
    if(pTrajectory_temp != NULL){
        delete []pTrajectory_temp;
        pTrajectory_temp = NULL;
    }
    
    if(pfKnots != NULL){
        delete []pfKnots;
        pfKnots = NULL;
    }
    if(pfLength != NULL){
        delete []pfLength;
        pfLength = NULL;
    }
    if(pPointCount != NULL){
        delete []pPointCount;
        pPointCount = NULL;
    }
    if(pInitIndex != NULL){
        delete []pInitIndex;
        pInitIndex = NULL;
    }
    if(pPointCount_temp != NULL){
        delete []pPointCount_temp;
        pPointCount_temp = NULL;
    }
    if(pInitIndex_temp != NULL){
        delete []pInitIndex_temp;
        pInitIndex_temp = NULL;
    }
    if(pnPointCount_K != NULL){
        delete []pnPointCount_K;
        pnPointCount_K = NULL;
    }
    if(pnInitIndex_K != NULL){
        delete []pnInitIndex_K;
        pnInitIndex_K = NULL;
    }
	if(gpiCount != NULL){
		delete []gpiCount;
		gpiCount = NULL;
	}
/*	if(local_displacement != NULL){
		delete []local_displacement;
		local_displacement = NULL;
	}
	
		if(local_pointcount != NULL){
		delete []local_pointcount;
		local_pointcount = NULL;
	}
*/	
	if(index != NULL){
		delete []index;
		index = NULL;
	}
/*	if(datatype != NULL){
		delete []datatype;
		datatype = NULL;
	}
*/	
/*	if(pfTrajectory_mpi != NULL){
		delete []pfTrajectory_mpi;
		pfTrajectory_mpi = NULL;
	}
*/
	if(myrank_mpi == 0)
	{
		cout<<"The sampling is done !"<<endl;
	}
//	MPI_Win_free(&countwin);        
    MPI_Finalize();
    return 0;
}
