/**
 * cxlinepoint.cpp:
 *
 * Copyright (c) Hongfeng Yu <hfstudio@gmail.com>
 *
 * All rights reserved.  May not be used, modified, or copied
 * without permission.
 *
 */


#include "cxlinepoint.h"

cxLinePoint::cxLinePoint()
{
    m_fMag = 0;
    m_cFlag = 0;
}

cxLinePoint::cxLinePoint(cx3DVector pos, cx3DVector tangent, float mag, 
                         char flag)
{
    m_vPos = pos;
    m_vTangent = tangent;
    m_fMag = mag;
    m_cFlag = flag;
}

cxLinePoint::cxLinePoint(cx3DVector pos)
{
    m_vPos = pos;
}

cxLinePoint::cxLinePoint(const cxLinePoint &point)
{
    m_vPos = point.m_vPos;
    m_vTangent = point.m_vTangent;
    m_fMag = point.m_fMag;
    m_fCurvature = point.m_fCurvature;
    m_cFlag = point.m_cFlag;
}

cxLinePoint::~cxLinePoint()
{
}


const cxLinePoint & cxLinePoint::operator= (const cxLinePoint &right)
{
    m_vPos = right.m_vPos;
    m_vTangent = right.m_vTangent;
    m_fMag = right.m_fMag;
    m_fCurvature = right.m_fCurvature;
    m_cFlag = right.m_cFlag;
    return *this;
}

cxLinePoint operator+ (const cxLinePoint& left,
                       const cxLinePoint & right)
{
    return cxLinePoint(left.m_vPos     + right.m_vPos,
                       left.m_vTangent + right.m_vTangent,
                       left.m_fMag     + right.m_fMag);
}

cxLinePoint operator- (const cxLinePoint& left,
                       const cxLinePoint & right)
{
    return cxLinePoint(left.m_vPos     - right.m_vPos,
                       left.m_vTangent - right.m_vTangent,
                       left.m_fMag     - right.m_fMag);
}

cxLinePoint operator* ( const cxLinePoint& left, float right)
{
    return cxLinePoint(left.m_vPos     * right,
                       left.m_vTangent * right,
                       left.m_fMag     * right);
}
