/**
 * cxlinepoint.h:
 *
 * Copyright (c) Hongfeng Yu <hfstudio@gmail.com>
 *
 * All rights reserved.  May not be used, modified, or copied
 * without permission.
 *
 */


#ifndef CXLINEPOINT_H
#define CXLINEPOINT_H

#include "cx3dvector.h"


class cxLinePoint
{
public:
    cxLinePoint();
    
    cxLinePoint(cx3DVector pos, cx3DVector tangent, float mag, char flag = 0);

    cxLinePoint(cx3DVector pos);
    
    cxLinePoint(const cxLinePoint &point);

    ~cxLinePoint();

    const cxLinePoint & operator=  (const cxLinePoint &right);
    friend cxLinePoint operator+ ( const cxLinePoint& left,
                                   const cxLinePoint & right);
    friend cxLinePoint operator- ( const cxLinePoint& left,
                                   const cxLinePoint & right);
    friend cxLinePoint operator* ( const cxLinePoint& left, float right);
    
    void Pos(cx3DVector &v) {
        m_vPos = v;
    }

    cx3DVector Pos() {
        return m_vPos;
    }
        
    void Tangent(cx3DVector &v) {
        m_vTangent = v;
    }

    cx3DVector Tangent() {
        return m_vTangent;
    }

    void Mag(float f) {
        m_fMag = f;
    }


    float Mag() {
        return m_fMag;
    }
    
    void Curvature(float f) {
        m_fCurvature = f;
    }
    
    float Curvature() {
        return m_fCurvature;
    }
    
    void Flag(char c) {
        m_cFlag = c;
    }
    
    char Flag() {
        return m_cFlag;
    }
    
private:
    cx3DVector m_vPos;
    cx3DVector m_vTangent;
    float m_fMag;
    float m_fCurvature;
    char  m_cFlag;
};

#endif
